import { select,  
         map,
         csv,
         nest,
         ascending, 
         keys,
         treemap,
         sum,
         hierarchy,
         stratify
             } 
from 'd3';
//const sum = (accumulator, currentValue) => accumulator + currentValue;

const lead_time_country  =  nest()  
  .key( d => d.country) 
  .rollup( d => { return sum(d, d => d.lead_time );   } ); 

const lead_time_room  =  nest() 
  .key( d => d.country)
  .key( d => d.reserved_room_type) 
  .rollup( d => { return sum(d, d => d.lead_time );   } ); 

const client = map()
  .set("width", document.body.clientWidth )
  .set("height",document.body.clientHeight);
const margin = map()
  .set("width",20)
	.set("margin",30)
const svg = select("svg");

svg
  .attr('width',client.get('width'))
  .attr('height',client.get('height')) 

csv('population.csv').then( hotel => {
   
  hotel.forEach((h)=>{
     h.is_canceled =  +h.is_canceled;
     h.lead_time = +h.lead_time;
  }); 
  
  //var data = hierarchy({values: dataset_gen.entries(hotel)}, d => {  return d.values;});
console.log(lead_time_country.entries(hotel));  
  
var root_country = {} 
 
const strat_country =  lead_time_country.entries(hotel).map( d => 
 { return { "data" :{ "id": d.key  } ,"children": [d.value] };  } )

root_country.data = {}
root_country.data.id = "hotel"  
  
root_country.children = []
  
root_country.children.push(strat_country)
 
var root = hierarchy(root_country);
  
console.log(root);
  
const treeLayout = treemap()
  .size([ client.get("height") -margin.get("height"),
          client.get("width") -margin.get("width")
        ]) 
console.log(treeLayout(root)) 
  
}  );
 
